let fabricPort = undefined;

const compileStream = () => {
    const initRequest = {
        headers: {
        "Content-Type": "application/wasm",
        credentials: "same-origin"
        }
    };

    console.log("[compileWorker] Starting compileStreaming now");
    WebAssembly.compileStreaming(fetch("../bigfile.wasm", initRequest))
        .then(wasmModule => {
            console.log("[compileWorker] CompileStreaming has ended; Sending it over to instantiateWorker");
            if (fabricPort){
                fabricPort.postMessage({userData: {command: "instantiate", data: wasmModule}});
            }
        })
        .catch(err => console.error("ERROR!!: ", err));
};

self.onmessage = (message) => {
    const data = message.data.userData;

    switch(data.target){
        case "setPort":
            fabricPort = data.port;
            console.log("[compileWorker] messageChannel port set");
            break;
        case "compileStream":
            compileStream();
            break;
        default:
            throw "Unknown target for compileStreaming worker";
    }
};